Graphics3D 800,600,32,0
SetBuffer BackBuffer()

pxCreateWorld(1,"key")
pxSetGravity(0,-9.8,0)

cam=CreateCamera()
PositionEntity cam,0,5,-15
RotateEntity cam,20,0,0
light=CreateLight()

plane=CreateMirror()
plane_tex = CreatePlane()
EntityColor plane_tex,30,30,255
EntityAlpha plane_tex,0.5
MoveEntity plane_tex,0,0.1,0

sphere=CreateSphere()
sphere_body=pxBodyCreateSphere(1,10)
pxBodySetPosition sphere_body,0,5,0

Dim cube(10)
Dim cube_body(10)
For i=1 To 10
	cube(i)=CreateCube()
	cube_body(i)=pxBodyCreateCube(1,1,1,10)
	pxBodySetPosition(cube_body(i),Rnd(-10,10),Rnd(20),Rnd(-10,10))
Next

While Not KeyHit(1)
;DELTA-TIMING
	If user_time#=0 user_time#=MilliSecs()
	new_time#=MilliSecs()
	delta_t#=new_time#-user_time#
	user_time#=new_time#
;============

;PLAYER CONTROLLER
	keydownUP=KeyDown(200)
	keydownDOWN=KeyDown(208)
	keydownLEFT=KeyDown(203)
	keydownRIGHT=KeyDown(205)
	
	force=100
	max_speed=10

	If keydownUP Then pxBodyAddForce(sphere_body,0,0,(max_speed-pxBodyGetLinearSpeedZ(sphere_body))*force,0)
	If keydownDOWN Then	pxBodyAddForce(sphere_body,0,0,-(max_speed+pxBodyGetLinearSpeedZ(sphere_body))*force,0) 
	If keydownLEFT Then pxBodyAddForce(sphere_body,-(max_speed+pxBodyGetLinearSpeedX(sphere_body))*force,0,0,0) 
	If keydownRIGHT Then pxBodyAddForce(sphere_body,(max_speed-pxBodyGetLinearSpeedX(sphere_body))*force,0,0,0)
	If (Not keydownUP) And (Not keydownDOWN) Then pxBodyAddForce(sphere_body,0,0,-pxBodyGetLinearSpeedZ(sphere_body)*force,0)	
	If (Not keydownLEFT) And (Not keydownRIGHT) Then pxBodyAddForce(sphere_body,-pxBodyGetLinearSpeedX(sphere_body)*force,0,0,0)
;=================

;DOWN SPEED
	If KeyDown(57) Then ;IF PRESS SPACE
		newsphere=CreateSphere(32)
		PositionEntity newsphere, Rnd(-50,50),Rnd(0,10),Rnd(50,60)
	End If
;==========

	pxRenderPhysic(30/(delta_t#/30),0)		
	pxBodySetEntity(sphere,sphere_body)
	For i=1 To 10
		pxBodySetEntity(cube(i),cube_body(i))
	Next

	UpdateWorld
	
	RenderWorld
	
;DEBUG
	Text 0,0,"FPS: "+GetFPS()
	Text 0,20,"LinearSpeedX = "+pxBodyGetLinearSpeedX(sphere_body)
	Text 0,30,"LinearSpeedY = "+pxBodyGetLinearSpeedY(sphere_body)
	Text 0,40,"LinearSpeedZ = "+pxBodyGetLinearSpeedZ(sphere_body)
	Text  0,60,"   UP("+keydownUP+")"
	Text  0,70," DOWN("+keydownDOWN+")"
	Text  0,80," LEFT("+keydownLEFT+")"
	Text  0,90,"RIGHT("+keydownRIGHT+")"
	If k>10 Then
	  old_dt$="Delta_time = "+delta_t#
	  k=0
	Else
	  k=k+1
	End If
	Text 0,110,old_dt$
;=====
	
	Flip

Wend

End

;=====================================================================================================================================
Global FPS, FPS_temp, FPS_time
Function GetFPS()
ctime = MilliSecs()
FPS_temp = FPS_temp + 1
If ctime - FPS_time > 500 Then
	FPS = FPS_temp * 2
	FPS_temp = 0
	FPS_time = ctime
EndIf
Return FPS
End Function
;=====================================================================================================================================